UIPanelWindows["SpellTrackerFrame"] = { area = "doublewide", pushable = 0, width = 200, xoffset = 80, whileDead = 1 };

local SpellTrackerVersion="0.34";

SpellTracker = {};
SpellTracker.BARS = {}; -- stock les abbres qui sont cr au dbut et sont dans le cache

SpellTracker.ScrollValue = 0; -- valeur de la scrolbar virtuelle
SpellTracker.MaxVerticalScrollRange = 0;
SpellTracker.myPlayerGUID = UnitGUID("player");
	
function SpellTrackerFrame_Init(self)
	SpellTrackerDB = SpellTrackerDB or {};
	
	SpellTrackerDB.SPELLS = SpellTrackerDB.SPELLS or {}; -- stock les infos a afficher
	
	SpellTrackerDB.Params = SpellTrackerDB.Params or {};
	SpellTrackerDB.Params.SpellBarHeight = SpellTrackerDB.Params.SpellBarHeight or 20;
	SpellTrackerDB.Params.FrameWidth = SpellTrackerDB.Params.FrameWidth or 400;
	SpellTrackerDB.Params.FrameHeight = SpellTrackerDB.Params.FrameHeight or 400;
	SpellTrackerDB.Params.DefaultCountSpellsToTrack = 50; -- pilote le nombre de barres qui vont tre cres  l'avance
	
	SpellTrackerDB.SPELLSTOTTRACK = SpellTrackerDB.SPELLSTOTTRACK or {}; -- stock les sort  traquer
	
	SpellTrackerDB.CurrentPlayerTracked = SpellTrackerDB.CurrentPlayerTracked or {};
	SpellTrackerDB.CurrentPlayerTracked.GUID = SpellTrackerDB.CurrentPlayerTracked.GUID or UnitGUID("player");
	SpellTrackerDB.CurrentPlayerTracked.Name = SpellTrackerDB.CurrentPlayerTracked.Name or UnitName("player");
	SpellTrackerDB.CurrentPlayerTracked.lvl = SpellTrackerDB.CurrentPlayerTracked.lvl or UnitLevel("player");
	SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked = SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked or true;
	SpellTrackerDB.MsgToolTip = SpellTrackerDB.MsgToolTip or "Track Source";
	
	SpellTrackerButton_UpdateTitle();
	
	if ( UnitAffectingCombat("player") == nil ) then
		SpellTrackerFrame:SetWidth(SpellTrackerDB.Params.FrameWidth);
		SpellTrackerFrame:SetHeight(SpellTrackerDB.Params.FrameHeight);
	end
end
function SpellTrackerMinimapButton_OnClick(self)
    if (SpellTrackerFrame) then
        if(SpellTrackerFrame:IsVisible() ) then
            SpellTrackerFrame:Hide();
		else
            SpellTrackerFrame:Show();
			SpellTracker:UpdateFrame();
		end
    end
end
function hideSpellTrackerFrameButton_OnClick(self) -- Bouton pour fermer la mainFrame
	if (SpellTrackerFrame) then
        SpellTrackerFrame:Hide();
    end
end
function resetSpellTrackerButton_OnClick(self) -- Bouton pour reset les sorts traqus
	SpellTrackerDB.SPELLS = {};
	SpellTrackerButton_UpdateTitle();
	SpellTracker:UpdateFrame();
end
function otherTargetSpellTrackerButton_OnClick(self)
	if ( UnitGUID("target") ) then
		SpellTrackerDB.CurrentPlayerTracked.GUID = UnitGUID("target");
		SpellTrackerDB.CurrentPlayerTracked.Name = UnitName("target");
		SpellTrackerDB.CurrentPlayerTracked.lvl = UnitLevel("player");
	else
		SpellTrackerDB.CurrentPlayerTracked.GUID = UnitGUID("player");
		SpellTrackerDB.CurrentPlayerTracked.Name = UnitName("player");
		SpellTrackerDB.CurrentPlayerTracked.lvl = UnitLevel("player");
	end
	resetSpellTrackerButton_OnClick(self);
end
function AttackORAttackedSpellTrackerButton_OnClick(self)
	SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked = not SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked;
	if ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == true ) then
		SpellTrackerDB.MsgToolTip = "Track Source";
	elseif ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == false ) then -- peut valoir nil on sait jamais
		SpellTrackerDB.MsgToolTip = "Track Dest";
	end
	resetSpellTrackerButton_OnClick(self);
end
function SpellTrackerButton_UpdateTitle()
	local vers = SpellTrackerVersion;
	local pName = SpellTrackerDB.CurrentPlayerTracked.Name;
	local srcORdst = "";
	if ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == true ) then
		srcORdst = "SRC";
	elseif ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == false ) then
		srcORdst = "DST";
	end
	SpellTrackerFrameMainMenuTitleTitleText:SetText("SpellTracker r"..vers.." -- Player Tracked : "..pName.." by "..srcORdst);
end
function SpellTrackerButton_ShowTooltip(self, textToShow)
	if ( textToShow ) then
		GameTooltip:SetOwner(self);
		GameTooltip:SetText(textToShow);
	elseif ( SpellTrackerDB.MsgToolTip ) then
		GameTooltip:SetOwner(self);
		GameTooltip:SetText(SpellTrackerDB.MsgToolTip);
	end
end
function SpellTrackerButton_HideTooltip(self)
	 GameTooltip:Hide();
end
function SpellTrackerBar_OnEnter(self) -- affiche des infos sup sur les sort traqus
	if ( self.VAR.Used ) then 
		GameTooltip:SetOwner(self);
		GameTooltip:SetText(self.VAR.SpellName);
		GameTooltip:AddDoubleLine("Target Type :",self.VAR.TargetType);
		
		-- self.SpellHitType vaut "Heal" ou "Damage"
		GameTooltip:AddLine("|cFF33FF33---------- "..self.VAR.SpellHitType.." Hit : ----------");
		GameTooltip:AddDoubleLine("|cFF33FF33Amount :","|cFF33FF33"..FormatAmountValueToString(self.VAR.SpellHitAmount));
		GameTooltip:AddDoubleLine("|cFF33FF33Best :","|cFF33FF33"..FormatAmountValueToString(self.VAR.BestSpellHitAmount));
		GameTooltip:AddDoubleLine("|cFF33FF33Mean (Amount/Ticks) :","|cFF33FF33"..FormatAmountValueToString(self.VAR.MeanSpellHitAmount));
		GameTooltip:AddDoubleLine("|cFF33FF33Nombre de Hit :","|cFF33FF33"..tostring(self.VAR.CountSpellHit));
		
		GameTooltip:AddLine("|cFFFF9900---------- Over "..self.VAR.SpellHitType.." : ----------");
		GameTooltip:AddDoubleLine("|cFFFF9900Amount :","|cFFFF9900"..FormatAmountValueToString(self.VAR.SpellOver));
		GameTooltip:AddDoubleLine("|cFFFF9900Best :","|cFFFF9900"..FormatAmountValueToString(self.VAR.BestSpellOver));
		GameTooltip:AddDoubleLine("|cFFFF9900Mean (Amount/Ticks) :","|cFFFF9900"..FormatAmountValueToString(self.VAR.MeanSpellOver));
		GameTooltip:AddDoubleLine("|cFFFF9900Nombre de Over :","|cFFFF9900"..tostring(self.VAR.CountSpellOver));
		
		GameTooltip:AddLine("|cFF3366FF---------- "..self.VAR.SpellHitType.." Crit : ----------");
		GameTooltip:AddDoubleLine("|cFF3366FFAmount :","|cFF3366FF"..FormatAmountValueToString(self.VAR.SpellCritAmount));
		GameTooltip:AddDoubleLine("|cFF3366FFBest :","|cFF3366FF"..FormatAmountValueToString(self.VAR.BestSpellCritAmount));
		GameTooltip:AddDoubleLine("|cFF3366FFMean (Amount/Ticks) :","|cFF3366FF"..FormatAmountValueToString(self.VAR.MeanSpellCritAmount));
		GameTooltip:AddDoubleLine("|cFF3366FFNombre de Crit :","|cFF3366FF"..tostring(self.VAR.CountSpellCrit));
		
		GameTooltip:AddLine("|cFFCCCCCC--- "..self.VAR.SpellHitType.." Absorb/Block/Imune : ---");
		GameTooltip:AddDoubleLine("|cFFCCCCCCAmount :","|cFFCCCCCC"..FormatAmountValueToString(self.VAR.SpellAbsorbAmount));
		GameTooltip:AddDoubleLine("|cFFCCCCCCBest :","|cFFCCCCCC"..FormatAmountValueToString(self.VAR.BestSpellAbsorbAmount));
		GameTooltip:AddDoubleLine("|cFFCCCCCCMean (Amount/Ticks) :","|cFFCCCCCC"..FormatAmountValueToString(self.VAR.MeanSpellAbsorbAmount));
		GameTooltip:AddDoubleLine("|cFFCCCCCCNombre de Missed :","|cFFCCCCCC"..tostring(self.VAR.CountSpellMissed));
		GameTooltip:AddDoubleLine("|cFFCCCCCCNombre de Immune/Resisted :","|cFFCCCCCC"..tostring(self.VAR.CountSpellImmune));
		GameTooltip:AddDoubleLine("|cFFCCCCCCNombre de Absorb :","|cFFCCCCCC"..tostring(self.VAR.CountSpellAbsorb));
		
		GameTooltip:AddLine("----- "..self.VAR.SpellHitType.." Total Produced : -----");
		GameTooltip:AddDoubleLine("Amount :",FormatAmountValueToString(self.VAR.SpellAmountTotal));
		GameTooltip:AddDoubleLine("Mean (Amount/Ticks) :",FormatAmountValueToString(self.VAR.MeanSpellAmountTotal));
		GameTooltip:AddDoubleLine("Nombre de Ticks :",self.VAR.CountTicks);
		
		GameTooltip:Show();
	end
end
function FormatAmountValueToString(val)
	if (string.len(tostring(val)) > 4 ) then
		return string.format("%.0f", val/1000).."K";
	elseif (string.len(tostring(val)) > 7 ) then
		return string.format("%.0f", val/1000000).."m";
	elseif (string.len(tostring(val)) > 10 ) then
		return string.format("%.0f", val/1000000).."M";
	else
		return string.format("%.0f", val);
	end
end
function SpellTrackerBar_OnLeave(self)
    GameTooltip:Hide();
end
function SpellTrackerMinimapButton_OnEnter(self)
	GameTooltip:SetOwner(self);
	GameTooltip:SetText("SpellTracker r"..SpellTrackerVersion);
end
function SpellTrackerMinimapButton_OnLeave(self)
	GameTooltip:Hide();
end
function SpellTrackerResizeFrame_OnEnter(self) -- widget de redimentionnement -- survol IN
	if ( UnitAffectingCombat("player") == nil ) then
		SpellTrackerFrameResizeFrameTexture:SetDesaturated(false);
		SpellTrackerFrameResizeFrameTexture:SetAlpha(1);
	end
end
function SpellTrackerResizeFrame_OnLeave(self) -- widget de redimentionnement -- survol OUT
	if ( UnitAffectingCombat("player") == nil ) then
		SpellTrackerFrameResizeFrameTexture:SetDesaturated(true);
		SpellTrackerFrameResizeFrameTexture:SetAlpha(0);
	end
end
function SpellTrackerResizeFrame_OnMouseDown(self) -- widget de redimentionnement -- CLICK DOWN
	if ( UnitAffectingCombat("player") == nil ) then
		SpellTrackerFrame.isMovingOrSizing = false;
		SpellTrackerFrame:SetMinResize(80, 110);
		SpellTrackerFrame:SetMaxResize(800, 800);
		SpellTrackerFrame:StartSizing();
	end
end
function SpellTrackerResizeFrame_OnMouseUp(self) -- widget de redimentionnement -- CLICK UP
	if ( UnitAffectingCombat("player") == nil ) then
		SpellTrackerFrame:StopMovingOrSizing();
		SpellTrackerFrame:ClearAllPoints();
		SpellTrackerFrame.isMovingOrSizing = nil;
		SpellTrackerDB.Params.FrameWidth = SpellTrackerFrame:GetWidth();
		
		-- on reajuste la valuer y a un mulitple de Hbarre + offsety
		local barHeight = SpellTrackerDB.Params.SpellBarHeight + 2; -- 2 == offset
		print("----------------------------------------------");
		local newSpellTrackerFrameScrollLayoutHeight = math.ceil(SpellTrackerFrameScrollLayout:GetHeight() / barHeight)*barHeight;
		SpellTrackerFrameScrollLayout:SetHeight(newSpellTrackerFrameScrollLayoutHeight);
		local newSpellTrackerFrameHeight = (SpellTrackerFrame:GetHeight() - SpellTrackerFrameScrollLayout:GetHeight()) + newSpellTrackerFrameScrollLayoutHeight;
		print(SpellTrackerFrame:GetHeight());
		print(SpellTrackerFrameScrollLayout:GetHeight());
		print(newSpellTrackerFrameHeight);
		--SpellTrackerFrame:SetHeight(newSpellTrackerFrameHeight);
		SpellTrackerDB.Params.FrameHeight = newSpellTrackerFrameHeight;
		
		SpellTracker:InitFrame(); -- on a redimentionn donc on reinit le layout
	end
end
function SpellTrackerFrameScrollLayout_OnLoad(self) -- chargement du container du grid
	self:RegisterForDrag("LeftButton");
	self:SetScrollChild(SpellTrackerFrameScrollLayoutContainer);
end
function SpellTrackerFrameScrollLayoutVirtualScrollBar_OnMouseWheel (self, delta, stepSize) -- se produit quand la molette de la sourie roule
	if ( delta ) then
		-- SpellTracker.ScrollValue
		local minVal, maxVal = 0, SpellTrackerFrameScrollLayout:GetHeight();
		stepSize = SpellTrackerDB.Params.SpellBarHeight + 2; -- le step vaut la hauteur d'une barre + 2 == offsety
		if ( delta == 1 ) then
			SpellTracker.ScrollValue = max(minVal, SpellTracker.ScrollValue - stepSize);
		elseif ( delta == -1 ) then
			SpellTracker.ScrollValue = min(maxVal, SpellTracker.ScrollValue + stepSize);
		end
		-- Position du container
		--print("maxVal=",maxVal);
		local maxScroll = SpellTracker.MaxVerticalScrollRange;
		local newScroll = (maxScroll - maxVal) * (SpellTracker.ScrollValue / 100);
		--print("maxScroll=",maxScroll);
		--print("SpellTracker.ScrollValue=",SpellTracker.ScrollValue);
		--print("newScroll=",newScroll);
		SpellTrackerFrameScrollLayout:SetVerticalScroll(SpellTracker.ScrollValue); -- on change la valeur du scroll
		--print("SpellTrackerFrameScrollLayout:GetVerticalScroll=",SpellTrackerFrameScrollLayout:GetVerticalScroll());
		
	end
end	
function SpellTrackerFrame_OnLoad(self)
	self:RegisterEvent("VARIABLES_LOADED");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED"); -- recuper les event de combat 
    self:RegisterEvent("PLAYER_REGEN_DISABLED"); -- Get Aggro
    self:RegisterEvent("PLAYER_REGEN_ENABLED");	-- Leave Aggro
end
function SpellTrackerFrame_OnEvent(self, event, ...)
	if ( event == "VARIABLES_LOADED" ) then
		SpellTrackerFrame_Init(self);
		self:UnregisterEvent("VARIABLES_LOADED");
	elseif ( event == "PLAYER_ENTERING_WORLD" ) then
		if ( UnitAffectingCombat("player") == nil ) then
			SpellTracker:InitFrame();
			DEFAULT_CHAT_FRAME:AddMessage("SpellTracker "..SpellTrackerVersion.." LOADED");
			SpellTracker:UpdateFrame();
			self:UnregisterEvent("PLAYER_ENTERING_WORLD");
		else
			DEFAULT_CHAT_FRAME:AddMessage("SpellTracker "..SpellTrackerVersion.." NOT LOADED");
			DEFAULT_CHAT_FRAME:AddMessage("PLEASE RELOAD INTERFACE AFTER THE END OF YOUR FIGHT");
		end
	elseif ( event == "COMBAT_LOG_EVENT_UNFILTERED" ) then
		SpellTracker:COMBAT_LOG_EVENT_UNFILTERED(self, ...);
	end
end
function SpellTracker:CreateBar(frmName)
    local GuiBar = CreateFrame("Button", frmName, SpellTrackerFrame, "SpellTrackerBarTemplate");
        
	GuiBar:RegisterForClicks("AnyUp");
	
	GuiBar.GUI = {};
	GuiBar.GUI.SpellIcon = _G[frmName.."StatusBarSpellHitSpellIcon"];
	GuiBar.GUI.SpellNameLabel = _G[frmName.."StatusBarSpellHitSpellNameLabel"];
	GuiBar.GUI.SpellHitLabel = _G[frmName.."StatusBarSpellHitSpellHitLabel"];
	GuiBar.GUI.SpellOverHitLabel = _G[frmName.."StatusBarSpellHitSpellOverHitLabel"];
	GuiBar.GUI.SpellCritAmountLabel = _G[frmName.."StatusBarSpellHitSpellCritAmountLabel"];
	GuiBar.GUI.SpellAbsorbAmountLabel = _G[frmName.."StatusBarSpellHitSpellAbsorbAmountLabel"];
	GuiBar.GUI.StatusBarSpellHit = _G[frmName.."StatusBarSpellHit"];
	GuiBar.GUI.StatusBarSpellHit:SetValue(0);
	GuiBar.GUI.StatusBarSpellHit:SetMinMaxValues(0, 100);
	GuiBar.GUI.StatusBarSpellOverHit = _G[frmName.."StatusBarSpellOverHit"];
	GuiBar.GUI.StatusBarSpellOverHit:SetValue(0);
	GuiBar.GUI.StatusBarSpellOverHit:SetMinMaxValues(0, 100);
	GuiBar.GUI.StatusBarSpellCritAmount = _G[frmName.."StatusBarSpellCritAmount"];
	GuiBar.GUI.StatusBarSpellCritAmount:SetValue(0);
	GuiBar.GUI.StatusBarSpellCritAmount:SetMinMaxValues(0, 100);
	GuiBar.GUI.StatusBarSpellAbsorbAmount = _G[frmName.."StatusBarSpellAbsorbAmount"];
	GuiBar.GUI.StatusBarSpellAbsorbAmount:SetValue(0);
	GuiBar.GUI.StatusBarSpellAbsorbAmount:SetMinMaxValues(0, 100);
	
    GuiBar.VAR = {};
	GuiBar.VAR.SpellIconTex = nil; -- chemin de la texture du sort
	GuiBar.VAR.SpellId = 0; -- id du sort
	GuiBar.VAR.SpellName = "spell Name"; -- nom du sort
	GuiBar.VAR.SpellHitType = "Heal/Damage"; -- type du sort
	
	GuiBar.VAR.SpellHitAmount = 0; -- montant du sort
	GuiBar.VAR.BestSpellHitAmount = 0; -- Meilleur montant
	GuiBar.VAR.MeanSpellHitAmount = 0; -- Moyenne
	GuiBar.VAR.CountSpellHit = 0; -- Nombre de Hit
	
	GuiBar.VAR.SpellAbsorbAmount = 0; -- montant du sort qui est absorb bloqu ou immune
	GuiBar.VAR.BestSpellAbsorbAmount = 0; -- Meilleur montant
	GuiBar.VAR.MeanSpellAbsorbAmount = 0; -- Moyenne
	GuiBar.VAR.CountSpellMissed = 0; -- Nombre de Hit
	GuiBar.VAR.CountSpellImmune = 0; -- Nombre de Hit
	GuiBar.VAR.CountSpellAbsorb = 0; -- Nombre de Hit
	
	GuiBar.VAR.SpellAmountTotal = 0; -- montant total du sort => Hit + Crit + Over
	GuiBar.VAR.CountTicks = 0; -- nombre de spell
	
	GuiBar.VAR.SpellOver = 0; -- montant en trop du sort
	GuiBar.VAR.BestSpellOver = 0; -- Meilleur montant
	GuiBar.VAR.MeanSpellOver = 0; -- Moyenne
	GuiBar.VAR.CountSpellOver = 0; -- Nombre de Hit
	
	GuiBar.VAR.SpellCritAmount = 0; -- montant en critique du sort
	GuiBar.VAR.BestSpellCritAmount = 0; -- Meilleur montant
	GuiBar.VAR.MeanSpellCritAmount = 0; -- Moyenne
	GuiBar.VAR.CountSpellCrit = 0; -- Nombre de Hit
	
	GuiBar.VAR.TargetType = ""; -- type de cible : mob ou player
	GuiBar.VAR.SpellTracked = false; -- si le spell est demand a traquer
	
	GuiBar.VAR.Used = false; -- indique si la barre affiche des donnes actuellment ( remeit  false pendant le reset de la barre )
	
	GuiBar:SetBackdropColor(0.1, 0.1, 0.1, 0.9);
    GuiBar:SetBackdropBorderColor(0, 0, 0, 0);
	
	return GuiBar;
end
function SpellTracker:ResetBar(GuiBar)
	if ( GuiBar ) then
		GuiBar.GUI.SpellIcon:SetTexture(1,1,1,0); -- on la rend transparante => texture:SetTexture(r, g, b[, a]) avec a = 0
		GuiBar.GUI.SpellNameLabel:SetText("");
		GuiBar.GUI.SpellHitLabel:SetText("");
		GuiBar.GUI.SpellOverHitLabel:SetText("");
		GuiBar.GUI.SpellCritAmountLabel:SetText("");
		GuiBar.GUI.SpellAbsorbAmountLabel:SetText("");
		GuiBar.GUI.StatusBarSpellHit:SetValue(0);
		GuiBar.GUI.StatusBarSpellOverHit:SetValue(0);
		GuiBar.GUI.StatusBarSpellCritAmount:SetValue(0);
		GuiBar.GUI.StatusBarSpellAbsorbAmount:SetValue(0);
		GuiBar.VAR.Used = false;
	end
end
function SpellTracker:InitFrame()
	if ( #SpellTracker.BARS == 0 ) then
		local idx = 1;
		local countBarToCreate = SpellTrackerDB.Params.DefaultCountSpellsToTrack;
		for k=0,countBarToCreate do 
			local frmName = "SpellTrackerBar"..tostring(idx);
			local Bar = SpellTracker:CreateBar(frmName);
			--Bar:Hide();
			SpellTracker.BARS[idx] = Bar;
			idx = idx + 1;
		end
	end
	
	local offsetY = -2;
    local mFrameContainer = SpellTrackerFrameScrollLayoutContainer;
	
	local ncolMax, nrowMax, itW, itH = 0, 0, 0, 0;
	local nrowMax = math.ceil(#SpellTracker.BARS);
	
	mFrameContainer:SetWidth(SpellTrackerFrame:GetWidth());
	
	local itW = mFrameContainer:GetWidth();
    local itH = SpellTrackerDB.Params.SpellBarHeight;
	
	local heightMax = nrowMax * itH + offsetY * nrowMax * -1;
	
	mFrameContainer:SetHeight(heightMax);
	
    local lastGuiBar = nil;
	for idx, guiBar in pairs(SpellTracker.BARS) do
		if ( guiBar ) then
			guiBar:SetParent(mFrameContainer);
			if ( lastGuiBar == nil ) then
				guiBar:SetPoint("TOPLEFT", mFrameContainer, "TOPLEFT", 0, 0);
			else
				guiBar:SetPoint("TOPLEFT", lastGuiBar, "BOTTOMLEFT", 0, offsetY);
			end
			guiBar:SetWidth(itW);
			guiBar:SetHeight(itH);
			lastGuiBar = guiBar;
		end
    end
end
function SpellTracker:UpdateFrame()
	local SpellListToSort = {};
	for spellIndexer, spellStruct in pairs(SpellTrackerDB.SPELLS) do
        if ( spellIndexer and spellStruct ) then 
			tinsert(SpellListToSort, spellStruct);
        end
    end
	
	sort(SpellListToSort, 
		function(x,y)
			if ( x and y ) then
				if  ( x.SpellTracked and y.SpellTracked ) then
					return ( x.SpellAmountTotal > y.SpellAmountTotal ) ;
				elseif ( x.SpellTracked ) then 
					return true; 
				elseif ( y.SpellTracked ) then 
					return false;
				else -- not ( x.SpellTracked and y.SpellTracked ) 
					return ( x.SpellAmountTotal > y.SpellAmountTotal ) ;
				end	
			end
		end);
	
	for i, bar in pairs(SpellTracker.BARS) do
		if ( bar ) then
			if ( bar.VAR.Used ) then -- la barre est utlise;
				SpellTracker:ResetBar(bar); -- on la reset, car la cahcher va porvoquer une erreur en combat
			end
		end
	end
	
	local idx = 1;
    for spellIndexer, spellStruct in pairs(SpellListToSort) do
		if ( spellIndexer ) then
            local GuiBar = SpellTracker.BARS[idx];
			idx = idx + 1;
            if ( GuiBar ) then
                GuiBar.GUI.SpellIcon:SetTexture(spellStruct.SpellIconTex); -- Spell Icon
				GuiBar.VAR.SpellIconTex = spellStruct.SpellIconTex;
				
				GuiBar.VAR.SpellId = spellStruct.SpellId;
				GuiBar.VAR.SpellHitType = spellStruct.SpellHitType;
				local HitType  = "";
				if ( spellStruct.SpellHitType == "Heal" ) then HitType = "Heal";
				else HitType = "Dmg"; end
				GuiBar.GUI.SpellNameLabel:SetText(tostring(HitType).." - "..tostring(spellStruct.SpellName).." x"..tostring(spellStruct.CountTicks).." - "..tostring(spellStruct.TargetType)); -- Spell Name
				GuiBar.VAR.SpellName = spellStruct.SpellName;
				GuiBar.VAR.TargetType = spellStruct.TargetType;
				
				local dispSeuil = 1000;
				if ( SpellTrackerDB.CurrentPlayerTracked.lvl < 85 ) then
					dispSeuil = 1;
				end
		
				GuiBar.GUI.SpellHitLabel:SetText(FormatAmountValueToString(spellStruct.SpellHitAmount)); -- Spell Amount
				GuiBar.VAR.SpellHitAmount = spellStruct.SpellHitAmount;
				GuiBar.VAR.BestSpellHitAmount = spellStruct.BestSpellHitAmount;
				GuiBar.VAR.MeanSpellHitAmount = spellStruct.SpellHitAmount/spellStruct.CountTicks;
				GuiBar.VAR.CountSpellHit = spellStruct.CountSpellHit; -- Nombre de Hit
	
				GuiBar.GUI.SpellOverHitLabel:SetText(FormatAmountValueToString(spellStruct.SpellOver)); -- Spell Over Amount
				GuiBar.VAR.SpellOver = spellStruct.SpellOver;
				GuiBar.VAR.BestSpellOver = spellStruct.BestSpellOver;
				GuiBar.VAR.MeanSpellOver = spellStruct.SpellOver/spellStruct.CountTicks;
				GuiBar.VAR.CountSpellOver = spellStruct.CountSpellOver; -- Nombre de Hit
	
				GuiBar.GUI.SpellCritAmountLabel:SetText(FormatAmountValueToString(spellStruct.SpellCritAmount)); -- Spell Crit Amount
				GuiBar.VAR.SpellCritAmount = spellStruct.SpellCritAmount;
				GuiBar.VAR.BestSpellCritAmount = spellStruct.BestSpellCritAmount;
				GuiBar.VAR.MeanSpellCritAmount = spellStruct.SpellCritAmount/spellStruct.CountTicks;
				GuiBar.VAR.CountSpellCrit = spellStruct.CountSpellCrit; -- Nombre de Hit
	
				GuiBar.GUI.SpellAbsorbAmountLabel:SetText(FormatAmountValueToString(spellStruct.SpellAbsorbAmount)); -- Spell Crit Amount
				GuiBar.VAR.SpellAbsorbAmount = spellStruct.SpellAbsorbAmount;
				GuiBar.VAR.BestSpellAbsorbAmount = spellStruct.BestSpellAbsorbAmount;
				GuiBar.VAR.MeanSpellAbsorbAmount = spellStruct.SpellAbsorbAmount/spellStruct.CountTicks;
				GuiBar.VAR.CountSpellMissed = spellStruct.CountSpellMissed; -- Nombre de Hit
				GuiBar.VAR.CountSpellImmune = spellStruct.CountSpellImmune; -- Nombre de Hit
				GuiBar.VAR.CountSpellAbsorb = spellStruct.CountSpellAbsorb; -- Nombre de Hit
	
				if ( spellStruct.SpellAmountTotal > 0 ) then
					local HitAmount = spellStruct.SpellHitAmount*100/spellStruct.SpellAmountTotal;
					local OverHitAmount = spellStruct.SpellOver*100/spellStruct.SpellAmountTotal;
					local CritAmount = spellStruct.SpellCritAmount*100/spellStruct.SpellAmountTotal;
					
					GuiBar.GUI.StatusBarSpellHit:SetValue(HitAmount);
					GuiBar.GUI.StatusBarSpellOverHit:SetValue(HitAmount+OverHitAmount);
					GuiBar.GUI.StatusBarSpellCritAmount:SetValue(HitAmount+OverHitAmount+CritAmount);
					GuiBar.GUI.StatusBarSpellAbsorbAmount:SetValue(100);
				end
				
				GuiBar.VAR.SpellAmountTotal = spellStruct.SpellAmountTotal;
				GuiBar.VAR.MeanSpellAmountTotal = spellStruct.SpellAmountTotal/spellStruct.CountTicks;
				GuiBar.VAR.CountTicks = spellStruct.CountTicks;
				
				GuiBar.VAR.SpellTracked = spellStruct.SpellTracked;
				
				GuiBar.VAR.Used = true;
			end
		end
	end
	SpellTracker.MaxVerticalScrollRange =  idx * SpellTrackerDB.Params.SpellBarHeight + (-2 * idx * -1); -- -2 = offset y entre les barres   
end
function SpellTracker:WhatIsThisGuid(GUIDNumber)
	if ( GUIDNumber ~= nil and GUIDNumber ~= "" ) then
		local maskedB = tonumber(GUIDNumber:sub(5,5), 16) % 8; 
		local knownTypes = {[0]="player", [1]="object", [3]="mob", [4]="pet", [5]="vehicle"};
		local result = knownTypes[maskedB] or "Unknow";
		return result; 
    end
    return "Unknow";
end
function SpellTracker:COMBAT_LOG_EVENT_UNFILTERED(_,DATETIME, EVENTTYPE, hideCaster, GUIDSRC, SRC, SRCFLAG1, SRCFLAG2, GUIDDST, DST, DSTFLAG1, DSTFLAG2, ...)
	local TargetType, GUID = nil;
	if ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == true ) then
		GUID = GUIDSRC;
		TargetType = SpellTracker:WhatIsThisGuid(GUIDDST);
	elseif ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == false ) then
		GUID = GUIDDST;
		TargetType = SpellTracker:WhatIsThisGuid(GUIDSRC);
	end
        
	if ( GUID == SpellTrackerDB.CurrentPlayerTracked.GUID ) then
		if(EVENTTYPE == "SWING_DAMAGE") then --autoattack -- coups blanc
			SpellTracker:UpdateSpell("Damage", TargetType, EVENTTYPE, ...);
        elseif(	EVENTTYPE == "SPELL_PERIODIC_DAMAGE" 
				or EVENTTYPE == "SPELL_DAMAGE" 
				or EVENTTYPE == "DAMAGE_SPLIT" 
				or EVENTTYPE == "DAMAGE_SHIELD") then
			SpellTracker:UpdateSpell("Damage", TargetType, EVENTTYPE, ...);
        elseif(EVENTTYPE == "ENVIRONMENTAL_DAMAGE") then
			SpellTracker:UpdateSpell("Damage", TargetType, EVENTTYPE, ...);
        elseif(	EVENTTYPE == "SPELL_HEAL" 
				or EVENTTYPE == "SPELL_PERIODIC_HEAL") then
			SpellTracker:UpdateSpell("Heal", TargetType, EVENTTYPE, ...);
		elseif( EVENTTYPE == "SWING_MISSED"
				or EVENTTYPE == "SPELL_MISSED"
				or EVENTTYPE == "SPELL_PERIODIC_MISSED" ) then
			SpellTracker:UpdateSpell("Missed", TargetType, EVENTTYPE, ...);
        end
    end
end
function SpellTracker:UpdateSpell(SpellHitType, TargetType, EVENTTYPE, ...) -- SpellHitType = Heal or Damage / TargetType = player or MOB / 
	local SPELLID, SPELLNAME, SPELLSCHOOL, MISSEDTYPE, AMOUNT, MISSED, OVERKILL, SCHOOL, RESISTED, BLOCKED, ABSORBED, CRITICAL, GLANCING, CRUSHING;
	-- voir http://www.wowwiki.com/API_COMBAT_LOG_EVENT
	if ( string.find(EVENTTYPE, "_DAMAGE") ) then
		if ( EVENTTYPE == "SWING_DAMAGE" ) then
			AMOUNT, OVERKILL, SCHOOL, RESISTED, BLOCKED, ABSORBED, CRITICAL, GLANCING, CRUSHING = ...;
			SPELLNAME = "Coups Blancs";
			SPELLID = 0;
		else
			SPELLID, SPELLNAME, SPELLSCHOOL, AMOUNT, OVERKILL, SCHOOL, RESISTED, BLOCKED, ABSORBED, CRITICAL, GLANCING, CRUSHING = ...;
		end
	elseif ( string.find(EVENTTYPE, "_HEAL") ) then
		SPELLID, SPELLNAME, SPELLSCHOOL, AMOUNT, OVERKILL, ABSORBED, CRITICAL = ...;
	elseif ( string.find(EVENTTYPE, "_MISSED") ) then
		if ( string.find(EVENTTYPE, "SWING_MISSED") ) then
			MISSEDTYPE, AMOUNT = ...;
			SPELLNAME = "Coups Blancs";
			SPELLID = 0;
		else
			SPELLID, SPELLNAME, SPELLSCHOOL, MISSEDTYPE, AMOUNT = ...;
		end
		if ( MISSEDTYPE == "ABSORB" ) then ABSORBED = AMOUNT; end
		if ( MISSEDTYPE == "MISS" 
			or MISSEDTYPE == "IMMUNE" 
			or MISSEDTYPE == "PARRY" 
			or MISSEDTYPE == "DODGE" ) then MISSED = 0; AMOUNT = nil; end
		if ( MISSEDTYPE == "RESIST" ) then RESISTED = AMOUNT; end		
	end
	
	local SpellIndexer = tostring(SPELLNAME).."-"..TargetType;
		
	-- Init or not
	local SpellStruct = SpellTrackerDB.SPELLS[SpellIndexer] or {};
	SpellStruct.SpellAbsorbAmount = SpellStruct.SpellAbsorbAmount or 0; -- init ot not
	SpellStruct.BestSpellAbsorbAmount = SpellStruct.BestSpellAbsorbAmount or 0; -- init ot not
	SpellStruct.SpellCritAmount = SpellStruct.SpellCritAmount or 0; -- init ot not
	SpellStruct.BestSpellCritAmount = SpellStruct.BestSpellCritAmount or 0; -- init ot not
	SpellStruct.SpellHitAmount = SpellStruct.SpellHitAmount or 0; -- init ot not
	SpellStruct.BestSpellHitAmount = SpellStruct.BestSpellHitAmount or 0; -- init ot not
	SpellStruct.SpellOver = SpellStruct.SpellOver or 0; -- init ot not
	SpellStruct.BestSpellOver = SpellStruct.BestSpellOver or 0; -- init ot not
	SpellStruct.SpellAmountTotal = SpellStruct.SpellAmountTotal or 0; -- init ot not
	
	SpellStruct.CountTicks = SpellStruct.CountTicks or 0;
	SpellStruct.CountSpellHit = SpellStruct.CountSpellHit or 0; -- Nombre de Hit
	SpellStruct.CountSpellMissed = SpellStruct.CountSpellMissed or 0; -- Nombre de Hit
	SpellStruct.CountSpellImmune = SpellStruct.CountSpellImmune or 0; -- Nombre de Hit
	SpellStruct.CountSpellAbsorb = SpellStruct.CountSpellAbsorb or 0; -- Nombre de Hit
	SpellStruct.CountSpellOver = SpellStruct.CountSpellOver or 0; -- Nombre de Hit
	SpellStruct.CountSpellCrit = SpellStruct.CountSpellCrit or 0; -- Nombre de Hit
		
	-- Affect
	SpellStruct.SpellIconTex = ""; -- chemin de la texture du sort
	SpellStruct.SpellId = SpellStruct.SpellId or SPELLID; -- id du sort
	SpellStruct.SpellName = SPELLNAME; -- nom du sort	
	SpellStruct.SpellHitType = SpellHitType; -- type du sort
	SpellStruct.TargetType = TargetType;
	
	SpellStruct.SpellIconTex = GetSpellTexture(SPELLNAME);
	
	if ( MISSED ) then
		SpellStruct.CountSpellMissed = SpellStruct.CountSpellMissed + 1;
--		print("MISSED=",...);
	elseif( RESISTED ) then
		SpellStruct.CountSpellImmune = SpellStruct.CountSpellImmune + 1;
--		print("RESISTED=",...);
	elseif( BLOCKED ) then
		SpellStruct.CountSpellImmune = SpellStruct.CountSpellImmune + 1;
--		print("BLOCKED=",...);
	elseif( ABSORBED ) then
		SpellStruct.CountSpellAbsorb = SpellStruct.CountSpellAbsorb + 1;
--		print("ABSORBED=",...);
	end
	
	if ( GLANCING ) then
		print("GLANCING=",...);
	elseif ( CRUSHING ) then
		print("CRUSHING=",...);
	end
	
	MISSED = MISSED or 0; -- au cas ou ca vaudrait nil
	RESISTED = RESISTED or 0; -- au cas ou ca vaudrait nil
	BLOCKED = BLOCKED or 0; -- au cas ou ca vaudrait nil
	ABSORBED = ABSORBED or 0; -- au cas ou ca vaudrait nil
	
	CRITICAL = CRITICAL or 0; -- au cas ou ca vaudrait nil
	OVERKILL = OVERKILL or 0; -- au cas ou ca vaudrait nil
	
	if( CRITICAL == 1 ) then
		SpellStruct.CountSpellCrit = SpellStruct.CountSpellCrit + 1;
	else
		SpellStruct.CountSpellHit = SpellStruct.CountSpellHit + 1;
	end

	if ( OVERKILL > 0 ) then
		SpellStruct.CountSpellOver = SpellStruct.CountSpellOver + 1;
	end
	-- faudra faire un truc pour les over heal qui sont crit
	-- pour le moment ca merde ca
	
	SpellStruct.CountTicks = SpellStruct.CountTicks + 1;
	
	if ( AMOUNT and AMOUNT > 0 or ABSORBED > 0 ) then
		if ( AMOUNT ) then
			AMOUNT = AMOUNT - OVERKILL; -- on dit que si on a que de l'over c'est que du perdu et donc 0 amount pusique amount est considr comme utile au contraire de over qui est inutile
				-- Crit or Hit => Var used = AMOUNT
			if ( CRITICAL == 1 ) then
				SpellStruct.SpellCritAmount = SpellStruct.SpellCritAmount + AMOUNT; -- montant en critique du sort on compte que amount par over
				if ( AMOUNT > SpellStruct.BestSpellCritAmount ) then
					SpellStruct.BestSpellCritAmount = AMOUNT;
				end
			else
				SpellStruct.SpellHitAmount = SpellStruct.SpellHitAmount + AMOUNT; -- montant en hit du sort
				if ( AMOUNT > SpellStruct.BestSpellHitAmount ) then
					SpellStruct.BestSpellHitAmount = AMOUNT;
				end
			end
			
			-- Over Hit ou Crit => Var used = OVERKILL
			if ( OVERKILL > 0 ) then
				SpellStruct.SpellOver = SpellStruct.SpellOver + OVERKILL; -- montant en trop du sort
				if ( OVERKILL > SpellStruct.BestSpellOver ) then
					SpellStruct.BestSpellOver = OVERKILL;
				end
			end
				if ( SpellTrackerDB.SPELLSTOTTRACK[SPELLID] ) then
				SpellStruct.SpellTracked = true; -- si le spell est demand a traquer
			else
				SpellStruct.SpellTracked = false;
			end
			-- Amount Total => Var used = AMOUNT & OVERKILL
			SpellStruct.SpellAmountTotal = SpellStruct.SpellAmountTotal + (AMOUNT + OVERKILL); -- montant total du sort => Normal + Crit + Over
		else
			-- Absorb Total => Var used = RESISTED & BLOCKED & ABSORBED
			SpellStruct.SpellAbsorbAmount = SpellStruct.SpellAbsorbAmount + (RESISTED + ABSORBED);
			if ( (RESISTED + ABSORBED) > SpellStruct.BestSpellAbsorbAmount ) then
				SpellStruct.BestSpellAbsorbAmount = (RESISTED + ABSORBED);
			end
			-- Amount Total => Var used =  RESISTED & ABSORBED
			SpellStruct.SpellAmountTotal = SpellStruct.SpellAmountTotal + (RESISTED + ABSORBED); -- montant total du sort => Normal + Crit + Over
		end
		
		SpellStruct.Used = false; -- indique si la barre affiche des donnes actuellment ( remeit  false pendant le reset de la barre )
			
		-- on stock la struct
		SpellTrackerDB.SPELLS[SpellIndexer] = SpellStruct;
	end
	
	-- On maj la frame
	SpellTracker:UpdateFrame();
end
